// Code generated by "enumer -type=SelectorType -json -text -yaml -sql"; DO NOT EDIT.

//
package selectorTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _SelectorTypeName = "UnknownAttributeClassFontFaceIDTypeUniversal"

var _SelectorTypeIndex = [...]uint8{0, 7, 16, 21, 29, 31, 35, 44}

func (i SelectorType) String() string {
	if i < 0 || i >= SelectorType(len(_SelectorTypeIndex)-1) {
		return fmt.Sprintf("SelectorType(%d)", i)
	}
	return _SelectorTypeName[_SelectorTypeIndex[i]:_SelectorTypeIndex[i+1]]
}

var _SelectorTypeValues = []SelectorType{0, 1, 2, 3, 4, 5, 6}

var _SelectorTypeNameToValueMap = map[string]SelectorType{
	_SelectorTypeName[0:7]:   0,
	_SelectorTypeName[7:16]:  1,
	_SelectorTypeName[16:21]: 2,
	_SelectorTypeName[21:29]: 3,
	_SelectorTypeName[29:31]: 4,
	_SelectorTypeName[31:35]: 5,
	_SelectorTypeName[35:44]: 6,
}

// SelectorTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func SelectorTypeString(s string) (SelectorType, error) {
	if val, ok := _SelectorTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to SelectorType values", s)
}

// SelectorTypeValues returns all values of the enum
func SelectorTypeValues() []SelectorType {
	return _SelectorTypeValues
}

// IsASelectorType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i SelectorType) IsASelectorType() bool {
	for _, v := range _SelectorTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for SelectorType
func (i SelectorType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for SelectorType
func (i *SelectorType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("SelectorType should be a string, got %s", data)
	}

	var err error
	*i, err = SelectorTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for SelectorType
func (i SelectorType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for SelectorType
func (i *SelectorType) UnmarshalText(text []byte) error {
	var err error
	*i, err = SelectorTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for SelectorType
func (i SelectorType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for SelectorType
func (i *SelectorType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = SelectorTypeString(s)
	return err
}

func (i SelectorType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *SelectorType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := SelectorTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
